#include <cstdio>
#include <vector>
#include <string>

using namespace std;

vector < int > v;
inline int POP( void ) {
  if ( v.empty() ) { printf("sranje\n"); return -1000000000; }
  int x = v.back();
  v.pop_back();
  return x;
}
inline void PUSH( int x ) {
  v.push_back( x );
}


char str[8];
string cmd;

int main(void) {
  for ( ;; ) {
    scanf("%s", str);
    cmd = str;
    if ( cmd == "NUM" ) {
      int x; scanf("%d", &x);
      PUSH( x );
    } else if ( cmd == "SWP" ) {
      int a = POP(), b = POP();
      PUSH( a ); PUSH( b );
    } else if ( cmd == "ADD" ) {
      PUSH( POP() + POP() );
    } else if ( cmd == "MUL" ) {
      PUSH( POP() * POP() );
    } else if ( cmd == "END" ) {
      break;
    } else if ( cmd == "DIV" ) {
      int A = POP(); int B = POP();
      PUSH( B / A );
    } else if ( cmd == "DUP" ) {
      int A = POP(); PUSH( A ); PUSH( A );
    } else if ( cmd == "POP" ) {
      POP();
    } else if ( cmd == "SUB" ) {
      int A = POP(); int B = POP();
      PUSH( B - A );
    } else if ( cmd == "INV" ) {
      PUSH( -POP() );
    }
    printf("Cmd=%s stek=%d\n", cmd.c_str(), v.size());
  }
  
  for ( int i = 0; i < (int)v.size(); ++i )
    printf("%d ", v[i]);
  printf("\n");
  return 0;
}
