#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>

using namespace std;

#define MAX 1000010

int q[MAX];
int end[MAX];
int begin[MAX];
int output[MAX];

inline bool cmp( int a, int b ) {
  return end[a] < end[b];
}

int A[MAX];
int B[MAX];
int C[MAX];
int last[MAX];
int N, Q;

int main(void) {
  for (;;) {  
    scanf("%d%d", &N, &Q);
    if ( N == 0 && Q == 0 ) break;
    for ( int i = 0; i < N; ++i ) {
      scanf("%d", A + i);
      C[i] = B[i] = A[i];
    }
    
    sort( B, B + N );
    for ( int i = 0; i < N; ++i )
      A[i] = lower_bound( B, B + N, A[i] ) - B;
      
    
    for ( int i = 0; i < Q; ++i ) {
      scanf("%d%d", begin + i, end + i); --begin[i]; --end[i];
      q[i] = i;
    }
    
    sort( q, q + Q, cmp );
    memset( output, -1, sizeof( output[0] ) * Q );
    memset( last, -1, sizeof( last[0] ) * N );
    
    int right = -1, right_value = -1;
    int k = 0;
    for ( int i = 0; i < N; ++i ) {
      if ( last[ A[i] ] > right ) {
        right = last[ A[i] ];
        right_value = C[i]; // original
      }
      last[ A[i] ] = i;
      
      for ( ;k < Q && end[q[k]] <= i; ++k ) {
//        printf("k=%d q[k]=%d end=%d right=%d %d\n", k, q[k], end[q[k]], right, right_value);
        if ( right >=  begin[q[k]] )
          output[ q[k] ] = right_value;
      }
    }
    
    for ( int i = 0; i < Q; ++i )
      if ( output[i] != -1 )
        printf("%d\n", output[i]);
      else
        printf("OK\n");
    printf("\n");
  }
  return 0;
}
